# qmailqueue
# set logfile
# badmailfrom

Name: qmail
Version: 1.03
Release: art.rh9.3
Group: Utilities/System
URL: http://www.qmail.org/
Copyright: Check with djb@koobera.math.uic.edu
Packager: scott@atomicrocketturtle.com
Source0: ftp://koobera.math.uic.edu/pub/software/qmail-1.03.tar.gz
#Source1: ftp://koobera.math.uic.edu/pub/software/dot-forward-0.71.tar.gz
#Source2: ftp://koobera.math.uic.edu/pub/software/fastforward-0.51.tar.gz
#Source3: ftp://koobera.math.uic.edu/pub/software/rblsmtpd-0.70.tar.gz
#Source5: qmail-1.03-linux.init
Source5: qmail.init
#Source6: qmail-1.03-solaris.init
Source7: qmail-linux.sh
Source8: qmail-linux.csh
Source9: qmail-aliases
Source10: qmail-default
Source11: qmail-msglog
Source12: qmail-default-delivery
Source13: brand.c
Source14: auto_uids.c
Source15: smtp_psa
Source16: xinetd.qmqp
Source17: smtps_psa
Source18: relaylock
# obsolete?
Source19: smtp_auth
Source20: cmd5checkpw 
# cant get this to work
#Source21: qmail-smtpd-auth-0.31.tar.gz
Patch0: qmail-1.03.install.patch
Patch1: qmail-1.03.msglog.patch
Patch2: qmail-1.03.redhat.patch
Patch3: smtp-auth.patch
Patch4: qmail-1.03.ids.patch
Patch5: qmail-1.03-qmailqueue
Patch6: qmail-1.03-mfcheck.3.patch
Patch7: qmail-1.03.errno.patch
# cant get this to work
#Patch8: qmail-dns-qregexp-0.5.patch
Patch9: big-concurrency.patch
Patch10: ext_todo-20020524.patch
Patch11: ext_todo-20020524-add-big-todo.patch
Patch12: big-todo.103.patch
Summary: qmail Mail Transport Agent
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}
Provides: MTA smtpdaemon qmailmta qmail-server psa-qmail
Requires: chkconfig shadow-utils tcp_wrappers
Requires: tcp_wrappers
Conflicts: sendmail qmail-client
Obsoletes: psa-qmail

%description
qmail is a small, fast, secure replacement for the SENDMAIL package, which is
the program that actually receives, routes, and delivers electronic mail.

#The dot-forward and fastforward packages have been added to this distribution
#for (not 100%) SENDMAIL compatability.
#
#The rblsmtpd package has been added as an optional way to fight SPAM.
#
#*** Note: Be sure and read the documentation as there are some small but very
#significant differences between SENDMAIL and QMAIL and the programs that
#interact with them.
#
A sub-package, qmail-msglog, adds (configurable) message logging.  This has been
added as a sub-package since this necessarily slows things down a little bit and
the author feels it necessary to distinguish the added capability as an add-on
package.

An alternative package (smaller, easier to configure) is the qmail-client
package which will ONLY work on a LAN connected to the qmail mail server via
the QMQP protocol.

%package msglog
Requires: qmail
Summary: qmail Mail Transport Agent with Message Logging
Group: Utilities/System
%description msglog
qmail-msglog adds a (customizable) script that runs on each and every message
that goes through the mail system.  One usage example is to record Message IDs
in the log file.

%package client
Group: Utilities/System
Summary: qmail Mail Transport Agent
Provides: MTA smtpdaemon qmailmta
%description client
qmail-client is a small, fast, secure replacement for the SENDMAIL package,
which is the program that actually receives, routes, and delivers electronic
mail.

*** Note: This package is for a client only and REQUIRES the main qmail server
on a connected LAN.

*** Note: Be sure and read the documentation as there are some small but very
significant differences between SENDMAIL and QMAIL and the programs that
interact with them.

#
# MACROS
#
# Find users and groups and brand files with uids and gids.
# Set permissions, owners and groups
%define brand cd /var/qmail/bin; ./brand install instcheck qmail-lspawn qmail-queue qmail-rspawn qmail-showctl qmail-start; /var/qmail/bin/install -d

# Error message if users or groups already exist
%define user_group_error (echo "Error $? : Required user or group already exists, please check /etc/passwd, /etc/group, and /etc/shadow files."; exit 1)

%prep
%setup -q

# Fix install
%patch0 -p1
%patch2 -p1
# IDs patch
%patch4 -p1
%patch5 -p1

# MFCHECK patch.
# all this gets combined into patch8, but iz br0x0r3d!
%patch6 -p1
#regex/mfcheck
#%patch8 -p1

%patch7 -p1

#smtp auth
%patch3 -p0
#tar -xzvf %{SOURCE21}
#mv qmail-smtpd-auth-0.31/*.[ch] .
#patch -p0 <qmail-smtpd-auth-0.31/auth.patch

# big concurrency
%patch9 -p1
%patch12 -p1
#%patch10 -p1
#%patch11 -p0
fds=`ulimit -n`
let spawnlimit='(fds-6)/2'
echo $spawnlimit >conf-spawn




%build
cp $RPM_SOURCE_DIR/brand.c .
cp $RPM_SOURCE_DIR/auto_uids.c .
make
mv qmail-queue qmail-queue.orig
patch -p1 < $RPM_SOURCE_DIR/qmail-1.03.msglog.patch
make
mv qmail-queue qmail-queue.msglog
mv qmail-queue.orig qmail-queue
./compile -g brand.c
./load brand
make man

%install
extra=rc.d
/bin/rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/var/qmail
chmod 755 $RPM_BUILD_ROOT/var/qmail
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/var/qmail/alias
mkdir -p $RPM_BUILD_ROOT/var/qmail/control
mkdir -p $RPM_BUILD_ROOT/var/qmail/users
mkdir -p $RPM_BUILD_ROOT/var/qmail/bin/
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/qmail-1.03
mkdir -p $RPM_BUILD_ROOT/var/qmail/boot
mkdir -p $RPM_BUILD_ROOT/var/qmail/man
mkdir -p $RPM_BUILD_ROOT/var/qmail/mailnames
# Save old Install and Check
mv install install.old
mv instcheck instcheck.old
# Fix Install and Check
sed "s;/var/qmail;$RPM_BUILD_ROOT/var/qmail;" conf-qmail > conf-qmail.tmp
mv conf-qmail.tmp conf-qmail
# Compile Install and Check
make install instcheck
# Compress Man Pages
gzip *.[0-9]
# INSTALL IT
./install -c
# Check it
#./instcheck
# Move old versions of Install and Check back
mv install.old install
mv instcheck.old instcheck
cp qmail-queue.msglog $RPM_BUILD_ROOT/var/qmail/bin

# Copy documentation that qmail install didn't get.
cp BLURB* README SECURITY THANKS THOUGHTS TODO VERSION $RPM_BUILD_ROOT/var/qmail/doc

# Sendmail compatable fix for user to see mail queue
ln -s qmail/qmail-qread $RPM_BUILD_ROOT/var/qmail/bin/mailq

# Set up post installation programs
cp ./brand ./install ./instcheck ./config ./config-fast ./dnsfq ./dnsip ./dnsptr ./hostname ./ipmeprint $RPM_BUILD_ROOT/var/qmail/bin

# Set up boot procedures
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d

mkdir -p $RPM_BUILD_ROOT/etc/profile.d
cp $RPM_SOURCE_DIR/qmail-linux.sh $RPM_BUILD_ROOT/etc/profile.d/qmail.sh
cp $RPM_SOURCE_DIR/qmail-linux.csh $RPM_BUILD_ROOT/etc/profile.d/qmail.csh
chmod a+x $RPM_BUILD_ROOT/etc/profile.d/qmail*
cp $RPM_SOURCE_DIR/qmail-1.03-linux.init $RPM_BUILD_ROOT/etc/$extra/init.d/qmail
chmod a+x $RPM_BUILD_ROOT/etc/$extra/init.d/qmail

mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/usr/lib
(cd $RPM_BUILD_ROOT/usr/sbin;
ln -sf ../../var/qmail/bin/sendmail;
cd $RPM_BUILD_ROOT/usr/lib;
ln -sf ../../var/qmail/bin/sendmail;
cd $RPM_BUILD_ROOT/usr/bin;
ln -s ../../var/qmail/bin/newaliases
)

# Set up mailing aliases (Solaris already has these so we don't copy)
(cd $RPM_BUILD_ROOT/var/qmail/alias;
touch .qmail-root;
cp $RPM_SOURCE_DIR/qmail-msglog  .qmail-msglog
cp $RPM_SOURCE_DIR/qmail-default .qmail-default
chmod 644 .qmail*
)

# Set up control files.
(cd $RPM_BUILD_ROOT/var/qmail/control;
touch defaultdomain locals me plusdomain qmqpservers rcpthosts;
chmod 644 defaultdomain locals me plusdomain qmqpservers rcpthosts;
)

# Set up blank qmail/users
(cd $RPM_BUILD_ROOT/var/qmail/users;
touch assign include exclude mailnames subusers append
echo "." > assign
)

# Set up default delivery
cp $RPM_SOURCE_DIR/qmail-default-delivery $RPM_BUILD_ROOT/var/qmail/dot-qmail

# Add rc boot script
echo "#! /bin/sh" > $RPM_BUILD_ROOT/var/qmail/rc
echo "/etc/$extra/init.d/qmail start" >> $RPM_BUILD_ROOT/var/qmail/rc
chmod a+rx $RPM_BUILD_ROOT/var/qmail/rc

# Add xinetd configuration.
cp %{SOURCE15} $RPM_BUILD_ROOT/etc/xinetd.d/smtp_psa
cp %{SOURCE16} $RPM_BUILD_ROOT/etc/xinetd.d/qmqp
cp %{SOURCE17} $RPM_BUILD_ROOT/etc/xinetd.d/smtps_psa

# Add in psa binaries
cp %{SOURCE18} $RPM_BUILD_ROOT/var/qmail/bin/relaylock
cp %{SOURCE19} $RPM_BUILD_ROOT/var/qmail/bin/smtp_auth
cp %{SOURCE20} $RPM_BUILD_ROOT/var/qmail/bin/cmd5checkpw

%pre
# qmail Pre-install script.
# If package is being installed for the first time
if [ $1 = 1 ]; then

groupadd nofiles || %{user_group_error};
useradd -g nofiles -d /var/qmail qmaild || %{user_group_error};
useradd -g nofiles -d /var/qmail qmaill || %{user_group_error};
useradd -g nofiles -d /var/qmail qmailp || %{user_group_error};
useradd -g nofiles -d /var/qmail/alias alias || %{user_group_error};
groupadd qmail || %{user_group_error};
useradd -g qmail -d /var/qmail qmailq || %{user_group_error};
useradd -g qmail -d /var/qmail qmailr || %{user_group_error};
useradd -g qmail -d /var/qmail qmails || %{user_group_error};
groupadd -g 110 popuser || %{user_group_error};
useradd -g popuser -u 110 -d /var/qmail popuser || %{user_group_error};

#echo "Adding qmqp to /etc/$INET/services"
g=`grep -c ^qmqp /etc/$INET/services` || true
if [ $g -le 0 ]; then
   (cat /etc/$INET/services;
   echo "qmqp		628/tcp		qmqp		# QMAIL Queuing Protocol") > /etc/$INET/services.$$ && \
      mv /etc/$INET/services /etc/$INET/services.bak && \
      mv /etc/$INET/services.$$ /etc/$INET/services
fi # services

fi # End Package installed for first time.

%post
# qmail Post-install script
#%ifos Linux
# Set up start up routines
/sbin/chkconfig --add qmail
#%endif

# Brand with correct UID, GID.
%{brand}
#/var/qmail/bin/instcheck

# Set file permissions.
chown alias:qmail /var/qmail/alias

# Set for user access.
chmod u+s /var/qmail/bin/qmail-qread

# Run configuration script.
./config >> /tmp/qmail.install.$$.log 2>&1

# Set up aliases
#/var/qmail/bin/newaliases

%preun
# qmail Pre-uninstall script.
extra=rc.d

if [ -f /etc/$extra/init.d/qmail ]; then
        /etc/$extra/init.d/qmail stop
fi

# If package is being erased for the last time.
if [ $1 = 0 ]; then

   sed -e '/qmqp/d' /etc/$INET/services > /etc/$INET/services.$$ && \
      mv /etc/$INET/services /etc/$INET/services.bak && \
      mv /etc/$INET/services.$$ /etc/$INET/services
   # Need to kill -HUP inetd

   # Delete qmail users
   userdel alias    || true;
   userdel qmaild   || true;
   userdel qmailq   || true;
   userdel qmailr   || true;
   userdel qmails   || true;
   userdel qmaill   || true;
   userdel qmailp   || true;
   userdel popuser   || true;

   # Delete qmail groups
   groupdel qmail   || true;
   groupdel nofiles || true;
   groupdel popuser || true;

   /sbin/chkconfig --del qmail

fi

%postun
# qmail Post-uninstall script.

%pre msglog
# qmail-msglog Pre-install script.
extra=rc.d
/etc/$extra/init.d/qmail stop

%post msglog
# qmail-msglog Post-install script.
cd /var/qmail/bin
mv qmail-queue qmail-queue.pre.msglog
cp qmail-queue.msglog qmail-queue
%{brand}
#/var/qmail/bin/instcheck

%preun msglog
# qmail-msglog Pre-uninstall script.
if [ -f /var/qmail/bin/qmail-queue.pre.msglog ]; then
   cd /var/qmail/bin/
   mv qmail-queue.pre.msglog qmail-queue
fi

%pre client
# qmail-client Pre-install script.

%post client
# qmail-client Post-install script.
# Run configuration script.
cd /var/qmail/bin
# Set up for QMAIL CLIENT
rm qmail-queue
ln -sf qmail-qmqpc qmail-queue
# Configure client control files.
./config >> /tmp/qmail.install.$$.log 2>&1
# Remove unneeded control files generated by config
rm /var/qmail/control/locals
rm /var/qmail/control/rcpthosts

%postun client
# qmail-client Post-uninstall script.

%clean
# Clean up after compiling and installing.
#rm -rf $RPM_BUILD_ROOT

%files
# qmail package file list.
%defattr(-,root,root)
#%config /etc/aliases
%config(noreplace) /var/qmail/alias/.qmail-root
%config(noreplace) /var/qmail/alias/.qmail-default
%config /var/qmail/dot-qmail
%config(noreplace) /var/qmail/control/defaultdomain
%config(noreplace) /var/qmail/control/locals
%config(noreplace) /var/qmail/control/me
%config(noreplace) /var/qmail/control/plusdomain
%config(noreplace) /var/qmail/control/rcpthosts
%config(noreplace) /var/qmail/users/assign
%config /etc/xinetd.d/smtp_psa
%config /etc/xinetd.d/qmqp
%config /etc/xinetd.d/smtps_psa
%verify(not group) %config /var/qmail/users
%config /etc/profile.d/*
%docdir /usr/share/doc/qmail-1.03
%docdir /usr/man
%dir /var/qmail/mailnames/
/etc/rc.d/init.d/qmail
%attr(4455,root,root) /var/qmail/bin/smtp_auth
%attr(4455,root,root) /var/qmail/bin/cmd5checkpw
/var/qmail/bin/relaylock
/var/qmail/bin/mailq
/var/qmail/bin/brand
/var/qmail/bin/bouncesaying
/var/qmail/bin/condredirect
/var/qmail/bin/config
/var/qmail/bin/config-fast
/var/qmail/bin/datemail
/var/qmail/bin/dnsfq
/var/qmail/bin/dnsip
/var/qmail/bin/dnsptr
/var/qmail/bin/elq
/var/qmail/bin/except
/var/qmail/bin/forward
/var/qmail/bin/hostname
%verify(not md5 mtime) /var/qmail/bin/install
%verify(not md5 mtime) /var/qmail/bin/instcheck
/var/qmail/bin/ipmeprint
/var/qmail/bin/maildir2mbox
/var/qmail/bin/maildirmake
/var/qmail/bin/maildirwatch
/var/qmail/bin/mailsubj
/var/qmail/bin/pinq
/var/qmail/bin/predate
/var/qmail/bin/preline
/var/qmail/bin/qail
/var/qmail/bin/qbiff
/var/qmail/bin/qmail-clean
/var/qmail/bin/qmail-getpw
/var/qmail/bin/qmail-inject
/var/qmail/bin/qmail-local
%verify(not md5 mtime) /var/qmail/bin/qmail-lspawn
/var/qmail/bin/qmail-newmrh
/var/qmail/bin/qmail-newu
/var/qmail/bin/qmail-pop3d
/var/qmail/bin/qmail-popup
/var/qmail/bin/qmail-pw2u
/var/qmail/bin/qmail-qmqpc
/var/qmail/bin/qmail-qmqpd
/var/qmail/bin/qmail-qmtpd
%verify(not mode) /var/qmail/bin/qmail-qread
/var/qmail/bin/qmail-qstat
%verify(not md5 user mtime) /var/qmail/bin/qmail-queue
/var/qmail/bin/qmail-remote
%verify(not md5 mtime) /var/qmail/bin/qmail-rspawn
/var/qmail/bin/qmail-send
%verify(not md5 mtime) /var/qmail/bin/qmail-showctl
/var/qmail/bin/qmail-smtpd
%verify(not md5 mtime) /var/qmail/bin/qmail-start
/var/qmail/bin/qmail-tcpok
/var/qmail/bin/qmail-tcpto
/var/qmail/bin/qreceipt
/var/qmail/bin/qsmhook
/var/qmail/bin/sendmail
/var/qmail/bin/splogger
/var/qmail/bin/tcp-env
#%dir /var/qmail/bin
/usr/sbin/sendmail
/usr/lib/sendmail
#/usr/share/doc/qmail-1.03
#/usr/lib/qmail/*
#/var/qmail/alias
#/var/qmail/bin
/var/qmail/boot
/var/qmail/queue
#/var/qmail/control
/var/qmail/doc
/var/qmail/man
# queue left out on purpose as it is ALWAYS going to be different and non-verifiable.
/var/qmail/rc
#/var/qmail/users

# qmail-msglog package file list.
%files msglog
%defattr(-,root,root)
%config /var/qmail/alias/.qmail-msglog
/var/qmail/bin/qmail-queue.msglog

# qmail-client package file list.
%files client
%defattr(-,root,root)
%config /var/qmail/control
%ifos Linux
%config /etc/profile.d/*
%endif
#%docdir /usr/doc/qmail-1.03
#%docdir /usr/man
/var/qmail/bin/config
/var/qmail/bin/config-fast
/var/qmail/bin/datemail
/var/qmail/bin/dnsfq
/var/qmail/bin/dnsip
/var/qmail/bin/dnsptr
/var/qmail/bin/elq
/var/qmail/bin/hostname
/var/qmail/bin/ipmeprint
/var/qmail/bin/pinq
/var/qmail/bin/predate
/var/qmail/bin/qmail-inject
/var/qmail/bin/qmail-qmqpc
/var/qmail/bin/qmail-queue
/var/qmail/bin/qmail-showctl
/var/qmail/bin/sendmail
#%dir /var/qmail/bin
/usr/sbin/sendmail
/usr/lib/sendmail
#/usr/doc/qmail-1.03
#/usr/man/man*/*
#/var/qmail/bin
#/var/qmail/control
#/var/qmail/doc
#/var/qmail/man
#%dir /var/qmail

%changelog
* Sun Apr 01 2001 David Summers <david@summersoft.fay.ar.us>
  Release 18: Fixed minor problems caused by new versions of RPM.

* Sat Sep 30 2000 David Summers <david@summersoft.fay.ar.us>
  Release 17: Updated to work with Redhat 7.0 (and previous releases).
  Should work with Solaris but not yet tested.
  Now requires tcp_wrappers.
  Added "restart" and "flush" to /etc/init.d/qmail script.
  Added SSMTP (SSL SMTP). (Won't work without XINETD and STUNNEL).

* Thu Apr 06 2000 David Summers <david@summersoft.fay.ar.us>
  Release 16:
  Finally added /usr/lib/sendmail to be more sendmail compatible on Linux.

* Sun Mar 19 2000 David Summers <david@summersoft.fay.ar.us>
  Release 15:
  Fixed verify for different files.

* Thu Mar 16 2000 David Summers <david@summersoft.fay.ar.us>
- Release 14:
  Added "." to /var/qmail/users/assign so qmail-newu won't give error.
  (Thanks to kcozens@pc.ve3syb.on.ca)

* Tue Feb 08 2000 David Summers <dws@engr.uark.edu>
- Release 13:
  Changed "%ifos Solaris" to "%ifnos Linux".

* Mon Feb 07 2000 David Summers <david@summersoft.fay.ar.us>
- Release 12:
  Verified operation on Solaris. /etc/aliases already exists so don't treat it
     as a config file.

* Sun Feb 06 2000 David Summers <david@summersoft.fay.ar.us>
- Release 11:
  Added mfcheck optional spam patch.
  Took out extra Solaris init scripts.

* Sun Nov 28 1999 David Summers <david@summersoft.fay.ar.us>
- Release 10:
  Finally got around to adding newaliases link.
  Only copy aliases file for Linux because Solaris already has it.
  Fixed silly setting of files to qmail group (in docs and others).

* Thu Jul 08 1999 David Summers <dws@engr.uark.edu>
- Release 9: Ouch! RPM 3.0 changed from OS=SunOS to OS=solaris.

* Sat Jun 26 1999 David Summers <david@summersoft.fay.ar.us>
Release 8:
- Fixed to work with LinuxPPC Release 5, don't need "ppc patch" anymore, but brand had to change.
- Changed "install" to not require building by root.
- Changed (/etc/rc.d/init.d/qmail) to use Linux "chkconfig".
- Changed file unpacking to be silent.

* Tue Sep 01 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 7:
- Patch to work with MkLinux DR3 and LinuxPPC Release 4.

* Wed Aug 26 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 6:
- Changed rblsmtpd to optionally print logging information so by default it
won't print out to the SMTP socket when used with INETD.

* Mon Aug 24 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 5:
- Changed to rblsmtpd-0.70 package.

* Fri Aug 14 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 4:
- Added rblsmtpd-0.50 package.
- Fixed dot-forward and fast forward packages not to complain while compiling on
  Solaris.
- Added documentation that qmail install didn't get.

* Wed Aug 05 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 3:
- Added dot-forward-0.71 package.
- Added fastforward-0.51 package.

* Fri Jun 19 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 2:
- Now creates backups of /etc/inetd.conf and /etc/services files.
- Fixed problem with wiping out /etc/services caused by misplaced parenthesis.

* Mon Jun 15 1998 David W. Summers <david@summersoft.fay.ar.us>

Release 1:
- conf-patrn flip-flopped from 1.02 to 1.03, hence qmail-1.03.solaris.patch.
- Started with qmail-1.03 sources and qmail-1.02-9.spec file.

